<script>
import Vue from 'vue';
import _ from 'lodash';

export default Vue.extend({
  name: 'Careers',
  props: {
    jobId: {
      // You can find the job ID in the URL of the departments endpoint
      // https://boards-api.greenhouse.io/v1/boards/gitlab/departments/
      type: Number,
      default: 4011044002, // This is the ID for the Engineering job family
      required: false,
    },
  },
  data() {
    return {
      data: [],
    };
  },
  async fetch() {
    const request = await fetch(
      `https://boards-api.greenhouse.io/v1/boards/gitlab/departments/${this.jobId}?render_as=tree`,
    ).then((response) => response.json());

    // The Greenhouse API endpoint doesn't show all jobs in the department head node,
    // but will show all jobs in the children nodes. So we need to get the children nodes
    // and then get the jobs from those nodes.

    const result = [];

    const getTerminatedChildren = (parent) => {
      if (parent.children) {
        parent.children.forEach((child) => {
          if (child.children.length !== 0) {
            getTerminatedChildren(child);
          } else {
            result.push(child);
          }
        });
      }
    };

    getTerminatedChildren(request);

    const departmentsWithOpenings = result.filter(
      (item) => item.jobs.length !== 0,
    );

    let jobList = [];

    departmentsWithOpenings.forEach((job) => {
      jobList = jobList.concat(job.jobs);
    });

    if (jobList.length !== 0) {
      if (jobList.length > 5) {
        this.data = _.sampleSize(jobList, 5);
      } else {
        this.data = jobList;
      }
    } else {
      const allJobs = await fetch(
        'https://boards-api.greenhouse.io/v1/boards/gitlab/jobs',
      ).then((response) => response.json());

      this.data = _.sampleSize(allJobs.jobs, 5);
    }
  },
});
</script>

<template>
  <div class="careers">
    <SlpContainer>
      <SlpRow class="slp-my-96 careers__container" style="gap: 48px">
        <SlpColumn :cols="6" style="flex: initial">
          <SlpTypography variant="heading2-bold" tag="h2" class="slp-pb-16">
            We’re hiring. Join us!
          </SlpTypography>
          <SlpTypography variant="heading5-bold" tag="p" class="slp-pb-16">
            Contribute to a culture of empathy and productivity
          </SlpTypography>
          <SlpTypography variant="body2" tag="p" class="slp-pb-16">
            GitLab is an open core software company that develops a
            <a
              href="https://about.gitlab.com/solutions/devops-platform/"
              data-ga-name="devops-platform"
              data-ga-location="body"
            >
              DevOps Platform</a
            >
            used by more than 100,000 organizations. Our
            <a
              href="https://about.gitlab.com/company/mission/"
              data-ga-name="mission"
              data-ga-location="body"
              >mission</a
            >
            makes it clear that we believe in a world where everyone can
            contribute. We make that possible at GitLab by running
            <a
              href="https://about.gitlab.com/handbook/product/product-processes/"
              data-ga-name="operations"
              data-ga-location="body"
              >our operations</a
            >
            on our product and staying aligned with
            <a
              href="https://about.gitlab.com/handbook/values/"
              data-ga-name="values"
              data-ga-location="body"
              >our values</a
            >.
          </SlpTypography>
          <SlpTypography variant="body2" tag="p">
            We strive to create a transparent environment where all team members
            around the world feel that their voices are heard and welcomed. We
            also aim to be a place where people can show up as their full selves
            each day and contribute their best.
          </SlpTypography>
          <SlpButton
            :href="data.cta?.href ?? 'https://about.gitlab.com/jobs/all-jobs/'"
            data-ga-name="all-jobs"
            data-ga-location="body"
            variant="primary"
            class="slp-mt-32"
            >{{ data.cta?.text ?? 'View open roles at GitLab' }}</SlpButton
          >
        </SlpColumn>
        <SlpColumn :cols="6" style="flex: initial">
          <div class="careers__job-posts">
            <a
              v-for="(post, index) in data"
              :key="index"
              :href="post.absolute_url"
              class="slp-flex careers__post slp-pl-8"
              :data-ga-name="`${post.title}, ${post.location.name}`"
              data-ga-location="body"
            >
              <img src="/nuxt-images/icons/events/user.svg" />
              <SlpTypography variant="body2" tag="p" class="slp-py-16 slp-px-8">
                {{ post.title }}, ({{ post.location.name }})
              </SlpTypography>
            </a>
          </div>
        </SlpColumn>
      </SlpRow>
    </SlpContainer>
  </div>
</template>

<style lang="scss" scoped>
.careers {
  background: #f6f3fe;

  &__container {
    gap: 48px;
    flex-wrap: nowrap;

    @media screen and (max-width: $breakpoint-sm) {
      flex-wrap: wrap;
    }
  }

  &__job-posts {
    background: #fff;
    color: #7759c2;
    border-radius: 0 0 90px 0;
    padding: 56px 36px;
  }

  &__post:hover {
    background: #f6f3fe;
  }
}
</style>
